<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) 2.0.3                                                   |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2009 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+
// | Build: 529.3   Patch: 1                                                  |
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Users
 * @copyright (C) 2002-2009 Esselbach Internet Solutions
 */

/**
 * function AdminDoEditUser
 * A function to edit user in the database
 * @author Philipp Louis Esselbach
 */
function AdminDoEditUser()
{
	global $database, $security, $preferences, $system, $html, $words_users;
	$input_user_status = ( isset( $_POST[ 'input_user_status' ] ) ) ? $security -> checknum( $_POST[ 'input_user_status' ] ) : "" ;
	$input_user_loginname = ( isset( $_POST[ 'input_user_loginname' ] ) ) ? $security -> checkvar( $_POST[ 'input_user_loginname' ] ) : "" ;
	$input_user_name = ( isset( $_POST[ 'input_user_name' ] ) ) ? $security -> checkvar( $_POST[ 'input_user_name' ] ) : "" ;
	$input_user_password = ( isset( $_POST[ 'input_user_password' ] ) ) ? $security -> checkvar( $_POST[ 'input_user_password' ] ) : "" ;
	$input_user_email = ( isset( $_POST[ 'input_user_email' ] ) ) ? $security -> checkvar( $_POST[ 'input_user_email' ] ) : "" ;
	$input_user_day = ( isset( $_POST[ 'input_user_day' ] ) ) ? $security -> checkvar( $_POST[ 'input_user_day' ] ) : "" ;
	$input_user_month = ( isset( $_POST[ 'input_user_month' ] ) ) ? $security -> checkvar( $_POST[ 'input_user_month' ] ) : "" ;
	$input_user_year = ( isset( $_POST[ 'input_user_year' ] ) ) ? $security -> checkvar( $_POST[ 'input_user_year' ] ) : "" ;
	$input_user_title = ( isset( $_POST[ 'input_user_title' ] ) ) ? $security -> checkvar( $_POST[ 'input_user_title' ] ) : "" ;
	$input_user_homepage = ( isset( $_POST[ 'input_user_homepage' ] ) ) ? $security -> checkvar( $_POST[ 'input_user_homepage' ] ) : "" ;
	$input_user_location = ( isset( $_POST[ 'input_user_location' ] ) ) ? $security -> checkvar( $_POST[ 'input_user_location' ] ) : "" ;
	$input_user_occupation = ( isset( $_POST[ 'input_user_occupation' ] ) ) ? $security -> checkvar( $_POST[ 'input_user_occupation' ] ) : "" ;
	$input_user_interests = ( isset( $_POST[ 'input_user_interests' ] ) ) ? $security -> checkvar( $_POST[ 'input_user_interests' ] ) : "" ;
	$input_user_signature = ( isset( $_POST[ 'input_user_signature' ] ) ) ? $security -> checkvar( $_POST[ 'input_user_signature' ] ) : "" ;
	$input_user_configuration = ( isset( $_POST[ 'input_user_configuration' ] ) ) ? $security -> checkvar( $_POST[ 'input_user_configuration' ] ) : "" ;
	$input_user_icq = ( isset( $_POST[ 'input_user_icq' ] ) ) ? $security -> checkvar( $_POST[ 'input_user_icq' ] ) : "" ;
	$input_user_aim = ( isset( $_POST[ 'input_user_aim' ] ) ) ? $security -> checkvar( $_POST[ 'input_user_aim' ] ) : "" ;
	$input_user_yahoo = ( isset( $_POST[ 'input_user_yahoo' ] ) ) ? $security -> checkvar( $_POST[ 'input_user_yahoo' ] ) : "" ;
	$input_user_msnname = ( isset( $_POST[ 'input_user_msnname' ] ) ) ? $security -> checkvar( $_POST[ 'input_user_msnname' ] ) : "" ;
	$input_user_jabber = ( isset( $_POST[ 'input_user_jabber' ] ) ) ? $security -> checkvar( $_POST[ 'input_user_jabber' ] ) : "" ;
	$input_user_skype = ( isset( $_POST[ 'input_user_skype' ] ) ) ? $security -> checkvar( $_POST[ 'input_user_skype' ] ) : "" ;
	$input_user_showsignatures = ( isset( $_POST[ 'input_user_showsignatures' ] ) ) ? $security -> checknum( $_POST[ 'input_user_showsignatures' ] ) : "" ;
	$input_user_showavatars = ( isset( $_POST[ 'input_user_showavatars' ] ) ) ? $security -> checknum( $_POST[ 'input_user_showavatars' ] ) : "" ;
	$input_user_invisible = ( isset( $_POST[ 'input_user_invisible' ] ) ) ? $security -> checknum( $_POST[ 'input_user_invisible' ] ) : "" ;
	$input_user_timezone = ( isset( $_POST[ 'input_user_timezone' ] ) ) ? $security -> checkvar( $_POST[ 'input_user_timezone' ] ) : "" ;
	$input_user_notes = ( isset( $_POST[ 'input_user_notes' ] ) ) ? $security -> checkvar( $_POST[ 'input_user_notes' ] ) : "" ;
	$input_zid = ( isset( $_POST[ 'input_zid' ] ) ) ? $security -> checknum( $_POST[ 'input_zid' ] ) : "" ;
	$input_security_hash = ( isset( $_POST[ 'input_security_hash' ] ) ) ? $security -> checkvar( $_POST[ 'input_security_hash' ] ) : "" ;

	if( ( $system -> adminhashget() != $input_security_hash ) and( $preferences[ 'website_subsessions_admin' ] ) )
	{
		$html -> login( $words_users[ 'ERROR' ], $words_users[ 'INVALID_SESSION' ], "index.php" );
		exit;
	}

	$notice = "";

	if( !$input_user_name )
	{
		$notice = $words_users[ 'NO_USER_NAME' ];
	}
	elseif( !$input_user_loginname )
	{
		$notice = $words_users[ 'NO_LOGIN_NAME' ];
	}
	elseif( !preg_match( "/^[A-Z0-9._%-]+@[A-Z0-9[:alpha:]._%-]+\.[A-Z]{2,6}$/i", $input_user_email ) )
	{
		$notice = $words_users[ 'INVALID_EMAIL' ];
	}
	elseif( $input_user_day > 31 )
	{
		$notice = $words_users[ 'INVALID_DAY' ];
	}
	elseif( $input_user_month > 12 )
	{
		$notice = $words_users[ 'INVALID_MONTH' ];
	}
	elseif( $input_user_year > date( "Y" ) )
	{
		$notice = $words_users[ 'INVALID_YEAR' ];
	}
	elseif( $input_user_status > 6 or !$input_user_status )
	{
		$notice = $words_users[ 'INVALID_STATUS' ];
	}

	if( $notice )
	{
		AdminEditUser( $input_zid, $notice );
	}
	else
	{
		if( $input_user_password )
		{
			$input_password_hashed = $system -> hashpass( $input_user_password );
			$input_password_salt = md5( rand( 0, 32768 ) );
			$input_password = $system -> hashpass( $input_password_hashed . $input_password_salt );
			$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_users SET user_password = '" . $input_password . "', user_salt = '" . $input_password_salt . "' WHERE user_id = '" . $input_zid . "'" );
		}

		if( $input_user_status == 2 )
		{
			$query = $database -> dbquery( "SELECT user_loginname FROM " . DB_PREFIX . "esselbach_ct_users WHERE user_id = '" . $input_zid . "'" );
			list( $old_loginname ) = $database -> dbrow( $query );

			if( $input_user_loginname != $old_loginname )
			{
				$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_permissions SET permission_admin = '" . $input_user_loginname . "' WHERE permission_admin = '" . $database -> dbescape( $old_loginname ) . "'" );
				$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_adminsessions SET session_adminuser = '" . $input_user_loginname . "' WHERE session_adminuser = '" . $database -> dbescape( $old_loginname ) . "'" );
			}
		}

		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_users SET user_name = '" . $input_user_name . "', user_loginname = '" . $input_user_loginname . "', user_email = '" . $input_user_email . "', user_birthday = '" . $input_user_year . "-" . $input_user_month . "-" . $input_user_day . "', user_title = '" . $input_user_title . "', user_homepage = '" . $input_user_homepage . "', user_location = '" . $input_user_location . "', user_occupation = '" . $input_user_occupation . "', user_interests = '" . $input_user_interests . "', user_signature = '" . $input_user_signature . "', user_configuration = '" . $input_user_configuration . "', user_icq = '" . $input_user_icq . "', user_aim = '" . $input_user_aim . "', user_yahoo = '" . $input_user_yahoo . "', user_msnname = '" . $input_user_msnname . "', user_jabber = '" . $input_user_jabber . "', user_skype = '" . $input_user_skype . "', user_showsignatures = '" . $input_user_showsignatures . "', user_showavatars = '" . $input_user_showavatars . "', user_invisible = '" . $input_user_invisible . "', user_timezone = '" . $input_user_timezone . "', user_notes = '" . $input_user_notes . "', user_status = '" . $input_user_status . "' WHERE user_id = '" . $input_zid . "'" );
		$html -> login( $words_users[ 'EDIT_USER' ], $words_users[ 'USER_CHANGED' ], "index.php?action=manageusers" );
	}
}
?>